#include <stdio.h>
#include <stdlib.h>

#define TEMPFILE "tempfile.txt"
//tries to open file and closes the program if this fails.
FILE *fileOpen(char *filename, char *mode){ 
	FILE *f;
	f = fopen(filename, mode);
	if(f == NULL){
		printf("File %s could not be opened.\n", filename);
		exit(0);
	}
	return f;
}

void sort(char *source, char *destination){
	int x, min, max, i, first, count, tmp;
	FILE *src, *dst;
	src = fileOpen(source, "r");		//verify source exists
	dst = fileOpen(destination, "w"); 	//verify destination can be created.
	fclose(dst);
	dst = fileOpen(TEMPFILE, "w");//verify tempfile can be created. 
	fclose(dst);
	first = 1;
	while(fscanf(src, "%d", &x) != EOF){
		if(first){
			min = x;
			max = x;
			first = 0;
		}
		if(min > x)
			min = x;
		if(max < x)
			max = x;
	}
	for(tmp = i = min; i <= max; i = tmp){	//we calculate tmp during cycle
		rewind(src);
		dst = fileOpen(TEMPFILE, "a"); //append to tempfile
		count = 0;
		while(fscanf(src, "%d", &x) != EOF){
			if(i == x && count == 0){
				fprintf(dst, "%d ", i); //print to tempfile only once
			}
			if(x == i)
				count++;
			if(x > i && (tmp == i || tmp > x)) //new min
				tmp = x;
		}
		fprintf(dst, "%d\n", count);
		fclose(dst);
		if(i == max)
			tmp = max + 1;
	}
	fclose(src);
	src = fileOpen(TEMPFILE, "r"); //open tempfile for reading
	dst = fileOpen(destination, "w");
	while(fscanf(src, "%d %d", &x, &count) != EOF){
		for(i = 0; i < count; i++)
			fprintf(dst, "%d ", x);
		fprintf(dst, "\n");
	}
	fclose(src);
	fclose(dst);
	remove(TEMPFILE); 
}
 
int main(void){
    sort("unsorted.txt", "sorted.txt"); //quits if unsorted.txt doesn't exist, overwrites sorted.txt
    return 0;    
}
